# Programa para calcular el perímetro
# de unas formas
# 04.08.2022
# Fraga
import sys
import numpy as np
import cv2

n = len( sys.argv )
if n != 2 :
	print( "Args: nombre_imagen" )
	sys.exit(1)

nombre = sys.argv[1]

img1 = cv2.imread( nombre, cv2.IMREAD_GRAYSCALE )
print( img1.shape )

# element = cv2.getStructuringElement( cv2.MORPH_RECT, (3, 3) )
# element = cv2.getStructuringElement( cv2.MORPH_ELLIPSE, (3, 3) )
element = cv2.getStructuringElement( cv2.MORPH_CROSS, (3, 3) )

imgErosionada = cv2.morphologyEx( img1, cv2.MORPH_ERODE, element )

imgFinal = img1 - imgErosionada

cv2.imwrite( "perimetro.png", imgFinal )
