import sys
import numpy as np
import cv2

n = len( sys.argv )
if n != 2 :
	print( "Args: nombre_imagen" )
	sys.exit(1)

nombre = sys.argv[1]

img1 = cv2.imread( nombre, cv2.IMREAD_GRAYSCALE )
print( img1.shape )

# Separamos cada objeto dentro de la imagen binarizada
# En Structural Analysis and Shape Descriptors
# en la documentación de openCV
n, img2  = cv2.connectedComponents( img1, 8 )

print( n )
print( type(img2) )
print( img2.shape )

rows, cols = img2.shape
forma = np.zeros( img1.shape, np.uint8 )
i = 1
while i < n :
	# Copiar cada forma en una solo imagen
	# y guardarla
	print( "# Forma ", i )
	j = 0
	while j<rows :
		k = 0
		while k<cols :
			if img2[j,k] == i :
				forma[j,k] = 255
				print( k, j )
			else :
				forma[j,k] = 0
			k +=1 
		j +=1 

	nombre_salida = str(i) + ".png"
	cv2.imwrite( nombre_salida, forma )
	# Calcular los momentos de Hu para cada forma
	mom = cv2.moments( forma )
	hu = cv2.HuMoments( mom )
	print( i, end=' ' )
	j = 0
	while j < 7:
		print( hu[j,0], end=" " )
		j += 1 
	print( )

	i += 1
	
